package com.example.fuzzControll.service.impl;

import com.example.fuzzControll.conf.kittyProperties;
import com.example.fuzzControll.pojo.vo.testEntity;
import com.example.fuzzControll.service.generateMethodService;
import com.example.fuzzControll.tools.cmdTools;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

@Service
@Slf4j
public class generateMethodServiceImpl implements generateMethodService {
    cmdTools cmdTools = new cmdTools();
    @Autowired
    kittyProperties kitty;

    @Override
    public Map<String,List<String>> generation(testEntity testEntity) {
        String cmd = parseParameters(testEntity);
        return cmdTools.runProgramCmdAndResult(cmd);
    }

    public String parseParameters(testEntity testEntity) {
        switch (testEntity.getTestClassName().toLowerCase()) {
            case "foreach":
                return foreachCmd(testEntity);
            default:
                log.error("未知变异方法！[{}]", testEntity.getTestClassName());
                return null;
        }
    }

    private String foreachCmd(testEntity testEntity) {
        String target_host = null;
        String target_port = null;
        String s1 = null;
        String s2 = null;
        String s3 = null;
        try {
            target_host = testEntity.getParamJson()[0];
            target_port = testEntity.getParamJson()[1];
            s1 = testEntity.getParamJson()[2];
            s2 = testEntity.getParamJson()[3];
            s3 = testEntity.getParamJson()[4];
        } catch (Exception e) {
            log.error("http_dos_qemu参数解析失败！");
        }
        return kitty.getVenvPath() + " " + kitty.getMethodPath() + "generate_method_test.py -f " + s1 + " " + s2 + " " + s3+" --host="+target_host+" --port="+target_port;
    }
    //todo 还有很多生成方法
}
