package com.example.fuzzControll.service.impl;

import com.example.fuzzControll.conf.kittyProperties;
import com.example.fuzzControll.constents.vulnerabilityTypeConstent;
import com.example.fuzzControll.pojo.vo.testEntity;
import com.example.fuzzControll.service.vulnerabilityTypeService;
import com.example.fuzzControll.tools.cmdTools;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

@Slf4j
@Service("vulnerabilityTypeService")
public class vulnerabilityTypeServiceImpl implements vulnerabilityTypeService {
    cmdTools cmdTools = new cmdTools();
    @Autowired
    kittyProperties kitty;

    @Override
    public Map<String, List<String>> generation(testEntity testEntity) {
        String cmd = parseParameters(testEntity);
        return cmdTools.runProgramCmdAndResult(cmd);
    }

    public String parseParameters(testEntity testEntity) {
        switch (testEntity.getTestClassName().toLowerCase()) {
            case "array_index_out_of_bounds_vulnerabilit":
                return arrayIndexOutOfBoundsVulnerabilitCmd(testEntity);
            default:
                log.error("未知漏洞！[{}]", testEntity.getTestClassName());
                return null;
        }
    }

    private String arrayIndexOutOfBoundsVulnerabilitCmd(testEntity testEntity) {
        return kitty.getVenvPath() + " " + kitty.getVulnerabilityTypePath() +"vul_types_test.py "+ vulnerabilityTypeConstent.ARRAY_INDEX_OUT_OF_BOUNDS_VULNERABILIT ;
    }
    //todo 还有很多类型要写
}
